# Run the Compilation and arrange to read its input
proc RunCompile {trace_type trace_id wparent list_files log but} {
	global stream Glob_Pref Process env
	set lstarg [list $Glob_Pref(FortranExt) $Glob_Pref(File) $list_files]

	# search a free id in stream
	set id 1
	while (1) {
		if { ![info exists stream($id)] } {break}
		incr id
	}
PRINT "Stream $id is Free"

	# open a stream
	set compilcmd $env(TKFPW_HOME)/cmd/DoCompil.tcl
	if [catch {open "| tclsh $compilcmd $lstarg |& cat" } stream($id)] {
		# Insert the Error Message, i.e. stream($id)
		$log insert end $stream($id)\n
	} else {
		fileevent $stream($id) readable [list LogCompile $trace_type $trace_id $wparent $id $but $log]
		set Process($trace_type,compiling,$trace_id) running
PRINT "Stream $id is Opened"
		# Refresh the log output
		$log configure -state normal
 		$log delete 1.0 end
		# Re-Configure the Button to allow the user to kill the process.
		$but config -text "Kill the Process" \
		     -command [list StopCompile $trace_type $trace_id $wparent $id $but $log kill]
	}
}
# Read and log output from the program
proc LogCompile {trace_type trace_id wparent id but log} {
	global stream
	if [eof $stream($id)] {
		StopCompile $trace_type $trace_id $wparent $id $but $log done
	} else {
		gets $stream($id) line
		switch -glob -- $line {
		  {*Compiling*} {$log insert end $line\n COMPILING}
		  {*ERROR*}     {$log insert end $line ERROR ; $log insert end \n}
		  {*OK*}        {$log insert end $line OK ; $log insert end \n}
		  default       {$log insert end $line\n}
		}
		$log see end
		update idletasks
	}
}
# Stop the program and fix up the button
proc StopCompile {trace_type trace_id wparent id but log endstat} {
	global stream
	global Process

	$log insert end \n
	$log insert end "Wait Please : Stopping the process ..." WAIT
	$log see end
	update idletasks

	# close the id stream
	catch { close $stream($id) }
	catch { unset stream($id) }
PRINT "Stream $id is Closed"

	$log insert end "\n... Process Ended..." READY
	$log configure -state disabled
	$log see end
	update idletasks

	# Re-Configure the Button to enable a quit.
	$but config -text "Done" -state active \
		-command [list destroy $wparent]
#	focus $but
	set Process($trace_type,compiling,$trace_id) $endstat

}
